
enabled_fields = ['prompt', 'sampler_name', 'cfg_scale', 'resolution', 'use_upscaling', 'seed', 'steps', 'n', 'models']

field_buttons = {
		'sampler_name': ['k_lms', 'k_heun', 'k_euler', 'k_euler_a', 'k_dpm_2', 'k_dpm_2_a', 'k_dpm_fast', 'k_dpm_adaptive', 'k_dpmpp_2s_a', 'k_dpmpp_2m'],
		'cfg_scale': ['3.0', '5.0', '9.0', '15.0'],
		'resolution': ['768x512', '1024x512', '512x512', '512x1024', '512x768'],
		'use_upscaling': ['True', 'False'],
		'seed': ['random',],
		'steps': ['20', '30', '50', '75', '100'],
		'n': ['1', '2', '3', '4'],
		'models': ['Yiffy', 'Furry Epoch', 'Zack3D']
	}
	
limits = {
	'cfg_scale': {'type': 'float', 'min': 1, 'max': 20, 'multiple': 0.5},
	'use_upscaling': {'type': 'boolean'},
	'steps': {'type': 'integer', 'min': 5, 'max': 100, 'multiple': 5},
	'n': {'type': 'integer', 'min': 1, 'max': 5},
	'models': {'type': 'enum', 'allowed': ['Yiffy', 'Furry Epoch', 'Zack3D']},
	'seed': {'type': 'integer', 'min': 0, 'max': 1000000}
}

prompt_msg = {
	'prompt': 'Tell me the prompt. Remember to consider the model you want to use.',
	'negative_prompt': 'Tell me the negative prompt. This is what you <strong>don\'t</strong> want to see in the final image.',
	'sampler_name': 'What sampler do you want? Sampler changes the way noise is transformed into images.',
	'cfg_scale': 'The config scale specifies the "hardness" of the neural network: higher values will create stronger shapes. Please write a number from 1 to 50 or press a button.',
	'resolution': 'The resolution specifies the size and format of the image generated. Choose one, or write your own (up to 3072x3072, multiples of 64).',
	'seed': 'The seed specifies the unique shape of the generated image(s). Write a number from 0 to 1000000, or click on "random".',
	'steps': 'The amount of steps specified how much time will be spent generating the image. Higher values usually generate more defined images, but your wait time will dramatically increase! Choose one or write a number between 10 and 100.',
	'n': 'How many images do you want to generate? Up to 4.',
	'models': 'Please choose a model to use!\n- <strong>Yiffy</strong> = trained on top e621 posts\n- <strong>Furry Epoch</strong> = trained on 300k images from e621\n- <strong>Zack3D</strong> = trained on 100k images from e621, specializes in transformation, latex, tentacles, goo, ferals and bondage\n\nYou can also give me more than one prompt, split by commas, to generate multiple images with different models.'
}
